/**
 * Static helper class. Quicksort algorithm taken from
 * http://www.algolist.net/Algorithms/Sorting/Quicksort
 * @author czhihao
 *
 */
public class Sort {
	public static int[] quicksort(int[] array) {
		double[] arraydouble = new double[array.length];
		for(int i = 0; i < array.length; i++) {
			arraydouble[i] = (double)array[i];
		}
		 int[] order = new int[array.length];
		 for(int i = 0; i < order.length; i++) {
			 order[i] = i;
		 }
		 quicksort(arraydouble,0,arraydouble.length-1,order);
		for(int i = 0; i < array.length; i++) {
			array[i] = (int)arraydouble[i];
		}
		return order;
	}
	public static int[] quicksort(double[] array) {
		 int[] order = new int[array.length];
		 for(int i = 0; i < order.length; i++) {
			 order[i] = i;
		 }
		quicksort(array,0,array.length-1,order);
		return order;
	}
	private static void quicksort(double[] array, int left, int right, int[] order) {
		int index = partition(array,left,right,order);
		if(left < index-1) {
			quicksort(array,left,index-1,order);
		}
		if(index < right) {
			quicksort(array,index,right,order);
		}
	}
	private static int partition(double[] array,int left,int right, int[] order) {
		int i = left;
		int j = right;
		double tmp;
		double pivot = array[(left+right)/2];
		while(i <= j) {
			while(array[i] < pivot) {
				i++;
			}
			while(array[j] > pivot) {
				j--;
			}
			if(i <= j) {
				tmp = array[i];
				array[i] = array[j];
				array[j] = tmp;
				tmp = order[i];
				order[i] = order[j];
				order[j] = (int)tmp;
				i++;
				j--;
			}
		}
		return i;
	}
}
